# encoding: utf-8
require 'devise'
require 'net/ldap'

require 'devise_ldap_multiple/exception'
require 'devise_ldap_multiple/logger'
require 'devise_ldap_multiple/ldap/adapter'
require 'devise_ldap_multiple/ldap/connection'
require 'devise_ldap_multiple/concern'

# Open this class to allow myhash to be read (the data in an object of this type is within this instance variable)
class Net::LDAP::Entry
  attr_reader :myhash
end

# Nearly all configuration is in each scope.yml file under config/ldap/ for each scope.
module Devise

  # The default scope to use if devise doesn't map to a scope and a scope isn't manually specified
  # Can be overwritten by setting in file config/initializers/devise.rb
  mattr_accessor :ldap_default_scope
  @@ldap_default_scope = 'default'

end

# Add ldap_authenticatable strategy to defaults.
Devise.add_module(:ldap_authenticatable,
                  :route => :session, ## This will add the routes, rather than in the routes.rb
                  :strategy   => true,
                  :controller => :sessions,
                  :model  => 'devise_ldap_multiple/model')
